function handle_out = gui_handle_convert(handle_in)
%
% Converts handles between structure form and vector form automatically.
%
% Author:  Winfried Kernbichler
% Version: 1.0 
% Date:    October 17, 2001
% Status:  Workes very well in all tests at the moment
% Missing: Check of input

if all(ishandle(handle_in))
  handle_out = struct([]);
  for h = 1:length(handle_in(:))         % go through all handles
    obj_type = get(handle_in(h),'type'); % get type of object 
    len = 0;
    if isfield(handle_out,obj_type)      % determine number of entries in field
      len = eval(['length(handle_out.',obj_type,')']);
    end
    handle_out = setfield(handle_out,{1},obj_type,{len+1},handle_in(h)); % set
  end
elseif isstruct(handle_in)
  handle_out = [];
  objects = fieldnames(handle_in);         % all objects in GUI  
  for obj_l = 1:length(objects)            % cycle through objects
    obj = char(objects(obj_l));            % one object
    h = eval( ['handle_in.',obj] );        % get object handles
    h = h(ishandle(h));                    % make sure that they are handles
    h = h(:).';                            % make line vector
    handle_out = [handle_out,h];           % assign output
  end
end