function gui_set_numbered(handle_in,delim,varargin)
%
% Sets properties as given in values (see below) and numberes them like
% value_1, value_2, ...
%
% handle_in:  vector of handles or structure of handles
% delim:      delimiter for separation
%
% properties can be given as
%  1) list of properties and values
%     'prop1',val1,'prop2',val2, .....
%  2) structure of properties and values
%     struct( 'prop1',val1,'prop2',val2, .....)
%
%  Properties must be matlab object properties which can be abrevated
%  according to matlab rules.
% 
% Author:  Winfried Kernbichler
% Version: 1.0 
% Date:    October 17, 2001
% Status:  Workes very well in all tests at the moment
% Missing: Check of input

% convert structur to vector for easy use
if isstruct(handle_in)
  hin = gui_handle_convert(handle_in);
else
  hin = handle_in;
end

% create cells of properrties and values
if length(varargin)==1 & isstruct(varargin{1})
  S = varargin{1};
  prop  = fieldnames(S);
  value = struct2cell(S); 
else
  props = varargin(1:2:end);
  value = varargin(2:2:end);
end

for k = 1:length(props) % cycle through properties
  prop = props{k};
  val  = value{k};
  for l = 1:length(hin) % cycle through handles
    set(hin(l),prop,[val,delim,num2str(l)]);
  end
end
